#define NULL_TREE NULL
#define NULL_NODE NULL
//#include <stdbool.h>


typedef struct information{
    struct information *leftson,*rightbro;
    uint16_t content;
	uint16_t nodeId;
    }*myNode;
typedef myNode tTree; 

uint16_t serializeMatrix[20][2];

//create a new tree with two parameters
tTree newTree(uint16_t nodeId,uint16_t content){
  tTree root;
  
  root = (tTree)malloc (sizeof(struct information));
  /*if (!root){
    printf("Enough memory to allocate the data");
  }*/

  root->leftson = NULL;
	root->rightbro = NULL;
  root->content = content;
  root->nodeId = nodeId;

  return root;
}

//return the left son of a myNode
myNode LeftsonTree(myNode n,tTree T){
  return n->leftson;
}

//return the right brother of a myNode
myNode RightbroTree(myNode n,tTree T){
  return n->rightbro;
}

//return the content of a myNode
uint16_t ContentTree(myNode n,tTree T){
  return n->content;
}

void RewriteContentTree(uint16_t e,myNode n){
  n->content = e;
}

myNode RootTree(tTree T){
  return T;
}

//destroy the tree and free memory
void DestroyTree(tTree T){  
  if(T){
     DestroyTree(T->leftson);
     DestroyTree(T->rightbro);
     free(T);
  }
}

//insert the newTree as a left son of the myNode n
void InsertLeftSon(myNode n, tTree newTreeRoot){
  newTreeRoot->rightbro = n->leftson;
  n->leftson = newTreeRoot;
}

//insert the newTree as a right brother of myNode n
void InsertRightBrother(myNode n, tTree newTreeRoot){
/*	if(n == RootTree(newTreeRoot)){
		printf("Error because both trees have the same root");
		return ;
	}*/ 

	newTreeRoot->rightbro = n->rightbro;
	n->rightbro = newTreeRoot;
}

//delete left son of myNode n of the tree T
//be careful because just remove one myNode not all the branch
tTree CutLeftSon(myNode n){
  tTree Taux;
   
  Taux=n->leftson;
  if(Taux!=NULL_TREE){
    n->leftson=Taux->rightbro;
    Taux->rightbro=NULL_NODE;
  }
  
  return Taux;
}

//delete right borther of myNode n of tree T
//be careful because just remove one myNode not all the branch
tTree CutRightBrother(myNode n,tTree T){
  tTree Taux;
   
  Taux=n->rightbro;

  if(Taux != NULL_TREE){
    n->rightbro=Taux->rightbro;
    Taux->rightbro=NULL_NODE;
  }

  return Taux;
}

void WriteNode(myNode n){
  fprintf(stdout,"%d\n",n->content);
}



void PreorderTree(myNode n,tTree T){
	//WriteNode(n);
	dbg("Content","Preorder -- %d\n",n->nodeId);
	for(n=LeftsonTree(n,T); n != NULL_NODE; n = RightbroTree(n,T))
		PreorderTree(n,T);
}


void InorderTree(myNode n,tTree T){
  myNode c;

  c=LeftsonTree(n,T);
  if(c != NULL_NODE){
    InorderTree(c,T);
    WriteNode(n);
    for(c=RightbroTree(c,T); c!=NULL_NODE; c=RightbroTree(c,T))
      InorderTree(c,T);
  }
  else WriteNode(n);
}


void PostorderTree(myNode n,tTree T){
  myNode c;

  for(c=LeftsonTree(n,T);c != NULL_NODE; c = RightbroTree(c,T))
    PostorderTree(c,T);

  WriteNode(n);
}


void removeSubtree(uint16_t nod, tTree T){

		if (T->leftson != NULL_NODE){
			if( T->leftson->nodeId == nod){
				//printf("Node %d found, removing all subtree\n",T->leftson->nodeId);
				DestroyTree(T->leftson);
				T->leftson = NULL_NODE;
				return ;			
			}else
				removeSubtree(nod, T->leftson);
		}
	
		if (T->rightbro != NULL_NODE){
			if( T->rightbro->nodeId == nod){
				//printf("Node %d found, removing all subtree\n",T->rightbro->nodeId);
				DestroyTree(T->rightbro);
				T->rightbro = NULL_NODE;
				return ;
			}else
				removeSubtree(nod,T->rightbro);	
		}
}

//delete the nodes that are below a certain depth level
void blackListTree(tTree T, uint16_t depth){
	myNode n;
	uint16_t k = 0; 

	//if the depth is equal to 0 destroy everthing and return
	if (depth == 0 ){
	  	//printf("All level except the root are going to be cut\n",i,n->content);
		DestroyTree(T->leftson);
		T->leftson = NULL_NODE;
		return ;
	}

	
	while (n != NULL_NODE){
	  	//printf("We're at level %d with myNode %d\n",i,n->content);

		if (k == depth){
			//printf("The tree %d at level %d is going to be cut\n",n->nodeId,i);
			//cutTree = CutLeftSon(n);
			DestroyTree(n->leftson);
			n->leftson = NULL_NODE;
			
			while (n->rightbro != NULL_NODE){
				n = n->rightbro;
				//printf("Right brother -> %d\n",n->nodeId);
				if (LeftsonTree(n,T) != NULL_NODE){
					//printf("The left son %d of myNode %d at level %d is going to be cut\n",n->leftson->nodeId,n->nodeId,i);
					//cutTree = CutLeftSon(n);
					DestroyTree(n->leftson);
					n->leftson = NULL_NODE;
				}
			}
			break;
			
		}

		n = T->leftson; //is the same that n = n->leftson;
		k++;
  }

}

//delete all nodes which aren't in the list
void whiteListTree(myNode n,tTree T, uint16_t* list, uint16_t maxList){				
	uint16_t i;
	bool isInList = FALSE;
	bool isInList2 = FALSE;
	myNode nod;

	if (n->rightbro != NULL_NODE) {
		for (i=0;i<maxList;i++){
			if (n->rightbro->nodeId == list[i]){
				isInList2 = TRUE;
			}
		}
		if (!isInList2){
			DestroyTree(n->leftson);
			n->leftson = NULL_NODE;
			DestroyTree(n->rightbro);
			n->rightbro = NULL_NODE;
			return ;
		}
		whiteListTree(n->rightbro, T, list, maxList);
	}


	if (n->leftson != NULL_NODE){
		for (i=0;i<maxList;i++){
			if (n->leftson->nodeId == list[i]){
				isInList = TRUE;
			}
		}
		if (!isInList){
			DestroyTree(n->leftson);
			n->leftson = NULL_NODE;
			DestroyTree(n->rightbro);
			n->rightbro = NULL_NODE;
			return ;
		}
		whiteListTree(n->leftson, T, list, maxList);
	}

}

//I will implement findSmallest() in the main code

//no se si estará bien esta implementación. Depende de la forma con la que se mire el grafo. Preguntar.
/*uint16_t getSmallest(tTree T, uint16_t depth, uint16_t k, uint16_t* priv1, uint16_t* priv2){
	
	uint16_t i=0;	
	uint16_t pos = 0;
	myNode n;
	n = T->leftson;
	uint16_t treeNodes[10];

//save all the nodes till certain level in a vector, then sort the myNode and choose the first k-x nodes 

	while (n != NULL_NODE){
	  	//printf("We're at level %d with myNode %d\n",i,n->content);

		if (i == depth-1){
			//printf("The tree %d at level %d is going to be cut\n",n->nodeId,i);
			treeNodes[pos] = n->nodeId;
			pos++;
			
			while (n->rightbro != NULL_NODE){
				n = n->rightbro;
				//printf("Right brother -> %d\n",n->nodeId);
				treeNodes[pos]=n->nodeId;
				pos++;
			}
			break;
			
		}

		n = T->leftson; //is the same that n = n->leftson;
		i++;
  }	
	for (i=0;i<10;i++)
		printf("The nodes are: treeNodes[%d]=%d\n",i,treeNodes[i]);
	
}
*/

tTree copyRecurs(tTree T, tTree finalTree){	
	myNode new_myNode;

	if(T->rightbro != NULL_NODE){
		//printf("T->rightbro = %d\n",T->rightbro->nodeId);
		new_myNode = newTree(T->rightbro->nodeId,T->rightbro->content);
		InsertRightBrother(finalTree,new_myNode);
		//printf("finalTree->rightbro = %d\n",finalTree->rightbro->nodeId);
		copyRecurs(T->rightbro,finalTree->rightbro);	
	}
	if(T->leftson != NULL_NODE){
		//printf("T->leftson = %d\n",T->leftson->nodeId);
		new_myNode = newTree(T->leftson->nodeId,T->leftson->content);
		InsertLeftSon(finalTree, new_myNode);
		copyRecurs(T->leftson,finalTree->leftson);	
	}
//	if (finalTree->leftson->rightbro != NULL_NODE)
//		printf("finalTree->leftson->leftson->rightbro = %d\n",finalTree->leftson->rightbro->nodeId);
	return finalTree;
}
	


tTree copyTree(tTree T){
	tTree finalTree = newTree(T->nodeId,T->content);
	finalTree = copyRecurs(T,finalTree);
	//printf("finalTree->leftson->leftson->rightbro = %d\n",finalTree->leftson->leftson->nodeId);
	return finalTree;
}


void replaceSubtree(tTree newTreeRoot, tTree oldTree, tTree root){	
	myNode nod = root;
		
	//find the father of the oldTree parameter, remove the old tree and insert the new tree
	
	if (nod->leftson != NULL_NODE){
		if( nod->leftson->nodeId == oldTree->nodeId){
			//printf("Node %d found, saving its father\n",nod->leftson->nodeId);			
			removeSubtree(nod->leftson->nodeId,root);
			InsertLeftSon(nod, newTreeRoot);
			return ;
		}else
			replaceSubtree(newTreeRoot, oldTree, nod->leftson);
	}
	
	if (nod->rightbro != NULL_NODE) {
		if (nod->rightbro->nodeId == oldTree->nodeId){
			//printf("Node %d found, saving its father\n",nod->rightbro->nodeId);
			removeSubtree(nod->rightbro->nodeId,root);
			InsertRightBrother(nod,newTreeRoot);
			return ;
		}else
			replaceSubtree(newTreeRoot,oldTree, nod->rightbro);	
	}

	//printf("No se ha encontrado el nodo %d\n",oldTree->nodeId);
}


tTree findNodeId(uint16_t n, tTree T, tTree rootT){
	myNode nod = T;
	myNode ret1 = NULL;
	myNode ret2 = NULL;
	myNode rootNode = NULL;

	rootNode = RootTree(rootT);
	if (rootNode->nodeId == n)
		return rootT;

	if (nod->leftson != NULL_NODE){
		if (n == nod->leftson->nodeId){
			//printf("found in leftson\n");	
			return nod->leftson;
		}else{
			ret1 = findNodeId(n,nod->leftson,rootT);
		}
	}

	if (nod->rightbro != NULL_NODE){
		if (n == nod->rightbro->nodeId){
			//printf("Found in right son -- dir = %d\n",nod);	
			return nod->rightbro;
		}else{
			ret2 = findNodeId(n,nod->rightbro,rootT);
		}
	}
		
	if (ret1 != NULL)
		return ret1;
	if (ret2 != NULL)
		return ret2;

	return NULL;
}

/*
  tTree findNodeIdInLevel(uint16_t n, tTree T, tTree rootT, uint16_t level){
	myNode n,ret;
	uint16_t k = 0; 

	if (level == 0 ){
		if (rootNode->nodeId == n)
			return rootT;
		else
			return NULL;
	}

	
	while (n != NULL_NODE){
	  	//printf("We're at level %d with myNode %d\n",i,n->content);

		if (k == level-1){
			//printf("The tree %d at level %d is going to be cut\n",n->nodeId,i);

			ret = findNodeId(n, n->leftson, tTree rootT);
			if (ret != NULL)
				return RET;
			else{
				while (n->rightbro != NULL_NODE){
					ret = findNodeId(n, n->leftson, tTree rootT);
					if (ret != NULL)
						return ret;					
				}
			}
			break;
			
		}

		n = T->leftson; //is the same that n = n->leftson;
		k++;
  }
	return NULL;
  }
*/

bool isInTree(uint16_t nodeId, tTree n, tTree rootTree){
	bool ret;
	myNode n1;
	
	if (rootTree->nodeId == nodeId)
		return TRUE;

	if (nodeId == n->nodeId)
		return TRUE;

	for(n1=LeftsonTree(n,rootTree); n1 != NULL_NODE; n1 = RightbroTree(n,rootTree))
		ret = isInTree(nodeId,n1,rootTree);
	
	return FALSE;


}

/*
void serializeTreeRecurs(tTree T, uint16_t pos){

	if (T->leftson != NULL_NODE){
		pos++;
		serializeMatrix[pos][0]= T->leftson->nodeId;
		serializeMatrix[pos][1]= T->nodeId;		
		serializeTreeRecurs(T->leftson,pos);
	}


	if (T->rightbro != NULL_NODE){
		pos++;
		serializeMatrix[pos][0] = T->rightbro->nodeId;
		serializeMatrix[pos][1] = T->nodeId;
		serializeTreeRecurs(T->rightbro,pos);		
	}	
}*/
/*
void serializeTree(tTree T){
	serializeMatrix[0][0]=T->nodeId;
	serializeMatrix[0][1]=0;
	serializeTreeRecurs(T->leftson, 1);
	
} */

uint16_t countNodes(myNode n,tTree T){
  myNode c;
	uint16_t total=1;

  for(c =LeftsonTree(n,T);c != NULL_NODE; c = RightbroTree(c,T))
    total += countNodes(c,T) ;

  return total;
}


/*
tArbol CreateTreeFromVector(uint16_t content, tTree* treeVector, uint16_t treeVectorSize){
  uint16_t i;
  nodo n,aux,root;

  //Reservamos memoria para el nodo raiz
  root=(myNode)malloc(sizeof(struct information));

  if(!root){
    printf("Memoria Insuficiente.");
  }

  //Inicializamos el nodo raiz
  root->father=NULL;
  root->leftson=NULL;
  root->rightbro=NULL;
  root->content=content;

  //Un bucle para insertar los subarboles
  for(i=0;i<nodeVectorSize;i++){
    n = (myNode)treeVector[i];
    
	if (n == NULL) //there aren't more children
		break;

    if(root->leftson)
		aux->rightbro = n;
    else 
		root->leftson = n;
    aux = n;
    aux->rightbro = NULL;
    aux->father = root;
  }

  return(tTree)root;
}
*/
