package main;

public class Coordinate implements Comparable<Coordinate> {
    public int x;
    public int y;
 
    public Coordinate(int x, int y) {
	this.x = x;
	this.y = y;
    }

    public Coordinate plus(Coordinate d) {
	return new Coordinate(x + d.x, y + d.y);
    }

    public boolean equals(Coordinate c) {
	return x == c.x && y == c.y;
    }

    public boolean equals(Object o) {
	if(o instanceof Coordinate) {
	    return equals((Coordinate)o);
	} else {
	    return false;
	}
    }

    public int compareTo(Coordinate that) {
	if(this.y != that.y) {
	    return (this.y < that.y ? -2 : 2);
	} else if(this.x != that.x) {
	    return (this.x < that.x ? -1 : 1);
	} else {
	    return 0;
	}
    }
 
    public int squareDistanceTo(Coordinate c) {
	int dx = c.x - x;
	int dy = c.y - y;
	return dx*dx + dy*dy;
    }
    
    public int getX() {
	return x;
    }

    public int getY() {
	return y;
    }

    public String toString() {
	return "<"+x+","+y+">";
    }

}
 