package main;
import java.util.*;

/**
 * The stretch is the number of fake nodes that is to be added to the number of fake nodes before reaching a child
 * The modulo is the number of nodes to apply stretch to before starting over at 0.
 *
 * A modulo of 0 means no modulo willl be used.
 */
public class DepthStretchSettings {

    int defaultstretch;
    int defaultmodulo;
    int stretch[];
    int modulo[];
    
    public DepthStretchSettings(int defstr, int str[], int defmod, int mod[]) {
	defaultstretch = defstr;
	stretch        = str;
	defaultmodulo  = defmod;
	modulo         = mod;
    }

    public DepthStretchSettings(int def, int stretch[]) {
	this(def,stretch,0,null);
    }

    public DepthStretchSettings(int def) {
	this(def,null);
    }

    private DepthStretchSettings() {
	this(0);
    }

//     public void setDefault(int stretch,int modulo) {
// 	set(0,stretch,modulo);
//     }
    
//     public void set(int height,int stretch,int modulo) {
// 	setByIndex(getSetIndex(height),stretch,modulo);
//     }

//     public void setStretch(int height,int stretch) {
// 	set(height,stretch,-1);
//     }

//     public void setModulo(int height,int modulo) {
// 	set(height,-1,modulo);
//     }

//     private void setByIndex(int index,int stretch,int modulo) {
// 	if(stretch >= 0) {
// 	    stretchlist.set(index,stretch);
// 	}
// 	if(modulo >= 0) {
// 	    modulolist.set(index,modulo);
// 	}
//     }

    
    int getStretch(int depth) {
	if(stretch == null || depth < 0 || stretch.length <= depth) {
	    return defaultstretch;
	} else {
	    return stretch[depth];
	}
    }

    int getModulo(int depth) {
	if(modulo == null || depth < 0 || modulo.length <= depth) {
	    return defaultmodulo;
	} else {
	    return modulo[depth];
	}
    }
    


    public int getChildStretch(int depth, int childnumber) {
	int stretch = getStretch(depth);
	int modulo  = getModulo(depth);
	// System.out.println("/* height="+height+" childnumber="+childnumber+" stretch="+stretch+" modulo="+modulo+" */");
	if(modulo == 0) {
	    return childnumber * stretch;
	} else {
	    return (childnumber % modulo) * stretch;
	}
    }
    
//     private int getGetIndex(int height) {
// 	if(2 <= height && height <= LISTLEN) {
// 	    return height - 1;
// 	} else {
// 	    return 0;
// 	}
//     }

//     private int getSetIndex(int height) {
// 	if(2 <= height && height <= LISTLEN) {
// 	    return height - 1;
// 	} else if(height == 0) {
// 	    return 0;
// 	} else {
// 	    throw new RuntimeException("Cannot set height: "+height);
// 	}
//     }

//     public String toString() {
// 	String out="Default:  <"+stretchlist.get(0)+","+modulolist.get(0)+">\n";
// 	for(int i = 1; i <= LISTLEN; i++) {
// 	    out += "Depth "+i+": "+"<"+stretchlist.get(getGetIndex(i))+","+modulolist.get(getGetIndex(i))+">\n";
// 	    //out += "<"+stretchlist.get(i)+","+modulolist.get(i)+">";
// 	}
// 	return out;
//     }

    public String toString() {
	String out = "Stretch: "+defaultstretch+", "+Arrays.toString(stretch);
	return out + "Modulo:  "+defaultmodulo+", "+Arrays.toString(modulo);
    }
}

