package main;
public class GraphNodeStringWalker extends GraphWalker {

    StringBuffer b;
    
    public GraphNodeStringWalker(StringBuffer b) {
	this.b = b;
    }

    /**
     * Removes the last character if it is a c and returns true, or does nothing and returns false
     */
    public boolean cutLast(char c) {
	int lastindex = b.length()-1;
	if(lastindex >= 0 && b.charAt(lastindex) == c) {
	    b.delete(lastindex,lastindex+1);
	    return true;
	} else {
	    return false;
	}
    }

    public void cutLastComma() {
	cutLast(',');
    }

    public boolean isPrinting(GraphWalkerNodeDetails details) {
// 	return (details.pstate == GraphWalker.ParentState.FORWARD) || 
// 	    (details.pstate == GraphWalker.ParentState.BACKWARD && !details.revisit);
	return !details.usedlink;
    }

    public <E> void visitNode(GraphNode<E> parent, GraphNode<E> node, GraphWalkerNodeDetails details, GraphWalkerWalkDetails walkdetails) {
	switch(details.nstate) {
	case START:
	    //System.out.println(node.contentToString()+" "+details);
	    if(isPrinting(details)) {
		if(details.revisit)       	b.append("(");
		if(true)                  	b.append(node.contentToString());
		//if(true)                  	b.append("."+node.getNodeId());
		if(details.revisit)       	b.append(")");
	    }
	    break;
	case BEFORECHILDREN:
	    if(node.gotChildren()) {
		b.append("{");
	    }
	    break;
	case AFTERCHILDREN:
	    if(node.gotChildren()) {
		cutLastComma();
		if(!cutLast('{')) {
		    b.append("}");
		}
	    }
	    break;
	case BEFOREPARENTS:
	    if(node.gotParents()) {
		b.append("[");
	    }
	    break;
	case AFTERPARENTS:
	    if(node.gotParents()) {
		cutLastComma();
		if(!cutLast('[')) {
		    b.append("]");
		}
	    }
	    break;
	case END:
	    if(!details.firstnode && isPrinting(details)) {
		b.append(",");
	    }
	    break;
	default:
	    throw new RuntimeException("Unknown NodeState"+details.nstate);
	}
    }
}

