package main;
public class GraphSizeWalker extends GraphWalker {

    public int nodes;
    public int edges;
    
    public GraphSizeWalker() {
	nodes = 0;
	edges = 0;
    }

    public <E> void visitNode(GraphNode<E> parent, GraphNode<E> node, GraphWalkerNodeDetails details, GraphWalkerWalkDetails walkdetails) {
	switch(details.nstate) {
	case START:
	    if(!details.revisit) {
		nodes++;
	    }
	    if(!details.usedlink && parent != null) {
		//System.out.println("Link from "+parent.getContent()+" to "+node.getContent()+" counted");
		edges++;
	    } else if(parent != null){
		//System.out.println("Link from "+parent.getContent()+" to "+node.getContent()+" already used");
	    }
	    break;
	case BEFORECHILDREN:
	case AFTERCHILDREN:
	case BEFOREPARENTS:
	case AFTERPARENTS:
	case END:
	    break;
	default:
	    throw new RuntimeException("Unknown NodeState"+details.nstate);
	}
    }
}

