package main;
import java.io.*;
import java.awt.*;
import java.awt.image.*;

import javax.swing.*;
import javax.imageio.*;

/**
 * Code stolen from http://www.javalobby.org/articles/ultimate-image/
 * and slightly modified.
 *
 */

public class ImagePopup {
    

    public BufferedImage loadImage(String ref) {
	BufferedImage bimg = null;
	try {
	    bimg = ImageIO.read(new File(ref));
	} catch (Exception e) {
	    e.printStackTrace();
	}
	return bimg;
    }

    public void loadAndDisplayImage(JFrame frame,String filename) {
	BufferedImage loadImg = loadImage(filename);
	frame.setBounds(0, 0, loadImg.getWidth()+10, loadImg.getHeight()+30);
	JImagePanel panel = new JImagePanel(loadImg, 0, 0);
	frame.add(panel);
	frame.setVisible(true);
    }

    /* ============================================================ */

    private class JImagePanel extends JPanel{

	public static final long serialVersionUID = 1L;

	private BufferedImage image;
	int x, y;
	public JImagePanel(BufferedImage image, int x, int y) {
	    super();
	    this.image = image;
	    this.x = x;
	    this.y = y;
	}
	@Override
	    protected void paintComponent(Graphics g) {
	    super.paintComponent(g);
	    g.drawImage(image, x, y, null);
	}
    }

    /* ============================================================ */

    public static void popupImage(String filename, String title) {
	ImagePopup ia = new ImagePopup();
	JFrame frame = new JFrame(title);
	ia.loadAndDisplayImage(frame,filename);
    }
    
    
    public static void main(String[] args) {
	popupImage("gtt.png","GridTreeTester");
	System.out.println("Bye!");
    }
}
