package main;
import java.util.*;

public class InfoFlood {
    
    /**
     * A map from node id to ttl
     */
    TreeMap<Integer,Integer> content; 

    public InfoFlood() {
	content = new TreeMap<Integer,Integer>();
    }

    public void stepTTL() {
	Set<Integer> deletes = new TreeSet<Integer>();
	for(Map.Entry<Integer,Integer> entry : content.entrySet()) {
	    int node = entry.getKey();
	    int ttl  = entry.getValue();
	    if(ttl > 1) {
		content.put(node,ttl - 1);
	    } else {
		deletes.add(node);
	    }
	}
	for(int d : deletes) {
	    content.remove(d);
	}
    }

    public void addInfoFlood(InfoFlood other) {
	for(Map.Entry<Integer,Integer> entry : other.content.entrySet()) {
	    int node = entry.getKey();
	    int ttl  = entry.getValue();
	    int cttl = -1;
	    boolean got = content.containsKey(node);
	    if(got) {
		cttl = content.get(node);
	    } 
	    if(!got || ttl > cttl) {
		content.put(node, ttl);
	    }
	}
    }

    public InfoFlood getCopy() {
	InfoFlood newf = new InfoFlood();
	for(Map.Entry<Integer,Integer> entry : content.entrySet()) {
	    int node = entry.getKey();
	    int ttl  = entry.getValue();
	    newf.content.put(node, ttl);
	}
	return newf;
    }
	
    public void add(int node, int ttl) {
	int ottl = -1;	    boolean got = content.containsKey(node);
	if(got) {
	    ottl = content.get(node);
	} 
	if(!got || ttl > ottl) {
	    content.put(node, ttl);
	}
    }
	
    TreeMap<Integer,Integer> getMap() {
	return content;
    }

    public int size() {
        return content.size();
    }
    
    public String toString() {
	return content.toString();
    }
    
}
