package main;
import java.util.*;

public class ReportMaker {

    public static final int defaultdefaultlevel = 2;

    private int defaultlevel = 2;
    private TreeMap<Integer,StringBuffer> reportmap;
    
    public ReportMaker(int deflev) {
        defaultlevel = deflev;
	reportmap = new TreeMap<Integer,StringBuffer>();
    }

    public ReportMaker() {
        this(defaultdefaultlevel);
    }

    private void ensureLevel(int level) {
        if(!reportmap.containsKey(level)) {
            StringBuffer b = new StringBuffer();
            Integer lower = reportmap.lowerKey(level);
            if(lower != null) {
                StringBuffer lowerb = reportmap.get(lower);
                b.append(lowerb.toString());
            }
            reportmap.put(level,b);
        }
    }
    
    public void put(int level,String str) {
        // System.out.println("Putting '"+str+"'");
        ensureLevel(level);
        for(StringBuffer b : reportmap.tailMap(level).values()) {
            b.append(str);
        }
        // System.out.println("Result: "+reportmap);
    }

    public void putSeparateLine(int level,String str) {
        put(level, "\n");
        putLine(level, str);
        put(level, "\n");
    }

    public void putLine(int level,String str) {
        put(level, str);
        put(level, "\n");
    }

    public void putLine(String str) {
        putLine(defaultlevel, str);
    }

    public void put(String str) {
	put(defaultlevel, str);
    }

    public String toString(int level) {
        StringBuffer b = reportmap.get(level);
        if(b == null) {
            SortedMap<Integer,StringBuffer> submap = reportmap.headMap(level);
            if(submap == null || submap.size() == 0) {
                return "";
            } else {
                b = submap.get(submap.lastKey());
            }
        }
        return b.toString();
    }
    
    public String toString() {
	return toString(defaultlevel);
    }

    public static void main(String args[]) {
        ReportMaker test = new ReportMaker();
        int[] levels = new int[] {1,2,1,3,0,2,1,4};
        for(int i : levels) {
            test.putLine(i,""+i);
        }

        for(int i = 0; i <= 4; i++) {
            System.out.println(test.toString(i));
            System.out.println();
        }
        
    }


}