package main;

import java.util.ArrayList;

public class RoutGridTester {

    public static void main(String args[]) {
        int squareradiorange = 5;
        int width = 4;
        int height = 3;
        if(args.length == 3) {
            squareradiorange = new Integer(args[2]);
        } else {
            if(args.length == 2) {
                width  = new Integer(args[0]);
                height = new Integer(args[1]);
            } else if(args.length != 0) {
                System.err.println("Invalid number of arguments");
                System.exit(1);
            }
        }
	
	int k = 2;
	int r = 1;
        
        NetworkNodeFactory factory = new SpohnNodeFactory(k, r);
        Network net = buildRoutGridNetwork(factory, width, height, squareradiorange);
	SpohnTester.runSpohnNetwork(net);
    }




    public static int getX(int number, int width) {
        return number % width;
    }

    public static int getY(int number, int width) {
        return number / width;
    }

    public static Network buildRoutGridNetwork(NetworkNodeFactory factory, int width, int height,int squareradiorange) {
        NetworkBuilder nb = new NetworkBuilder(factory);
        int nodes = width * height;
        for(int i = 0; i < nodes; i++) {
            int ix = getX(i,width);
            int iy = getY(i,width);
            ArrayList<Integer> neighbors = new ArrayList<Integer>();
            for(int j = 0; j < nodes; j++) {
                if(i != j) {
                    int dx = ix - getX(j,width);
                    int dy = iy - getY(j,width);
                    if(dx*dx + dy*dy <= squareradiorange) {
                        neighbors.add(j);
                    }
                }
                int[] na = new int[neighbors.size()];
                for(int k = 0; k < neighbors.size(); k++) {
                    na[k] = neighbors.get(k);
                }
                nb.add(i, ix, iy, na);
            }
        }
        return nb.getNetwork();
    }
}
