package main;
import java.util.*;

/**
 *
 */
public class SpohnData {
    int id;
    int k;
    int r;

    /**
     * Map from node to tuple
     * 
     * H contains all nodes
     * D is the k smallest ones
     */
    TreeMap<Integer,SpohnTuple> H;
    TreeMap<Integer,SpohnTuple> D;

    //TreeSet<SpohnATuple> A;
    SpohnStatus status;
    int rounds;

    /**
     * Set of Tuples received since last step.
     *
     * The from field should be set to the sender of the information.
     */
    List<SpohnMessage> M;

    TreeSet<Integer> notificationSent;
    TreeSet<Integer> joinSent;
    

    SpohnMessage nextmessage;

    boolean scheduledEvent;

    String stepreport;
    public StringBuffer nodereport;

    public SpohnData(int id, int k, int r) {
	this.id = id;
	this.k = k;
	this.r = r;
	this.H = new TreeMap<Integer, SpohnTuple>();
	H.put(id, new SpohnTuple(id, id, 0));
	this.D = null;
	//this.A = null;
	status = SpohnStatus.UNKNOWN;
	rounds = 0;
	resetM();

        notificationSent = new TreeSet<Integer>();
        joinSent = new TreeSet<Integer>();
        
        scheduledEvent = false;
        nodereport = new StringBuffer();
    }

    public int getId() {
        return id;
    }

    public void resetM() {
	M = new ArrayList<SpohnMessage>();
    }

    public int getRoundtripTime() {
        return 2*r+1;
    }

    public int getPhaseOneTime() {
        return r;
    }

    public int getScheduledTime() {
        return getPhaseOneTime() + getRoundtripTime();
    }

    public int getConvergeTime() {
        return getScheduledTime() + getRoundtripTime();
    }


}