package main;

import java.util.*;

/**
 * The examples in spohn07
 */
public class SpohnExamples {

    public static void main(String args[]) {
        int example = 2;
        if(args.length > 0) {
            example = new Integer(args[0]);
        }
        switch(example) {
        case 1:
            firstExample();
            break;
        case 2:
            secondExample();
            break;
        case 3:
            thirdExample();
            break;
        default:
            System.err.println("Unknown example");
            System.exit(1);
        }
    }
    
    public static void firstExample() {
	int k = 2;
	int r = 2;
        NetworkNodeFactory factory = new SpohnNodeFactory(k, r);
        NetworkBuilder nb = new NetworkBuilder(factory);
	nb.add(0, 2, 4, new int[] {1,2});
	nb.add(1, 3, 4, new int[] {0,3,7});
	nb.add(2, 1, 4, new int[] {0,9});
	nb.add(3, 4, 3, new int[] {1,5,7});
	nb.add(4, 3, 2, new int[] {5,6,7,8});
	nb.add(5, 4, 1, new int[] {3,4,7,8});
	nb.add(6, 1, 1, new int[] {4,8,9});
	nb.add(7, 3, 3, new int[] {1,3,4,5});
	nb.add(8, 2, 0, new int[] {4,5,6,9});
	nb.add(9, 0, 3, new int[] {2,6,8});
        Network net = nb.getNetwork();
	SpohnTester.runSpohnNetwork(net);
    }

    public static void secondExample() {
	int k = 2;
	int r = 3;
        NetworkNodeFactory factory = new SpohnNodeFactory(k, r);
        NetworkBuilder nb = new NetworkBuilder(factory);
	nb.add(10, 0, 0, new int[] {50});
	nb.add(15, 0, 2, new int[] {20});
	nb.add(18, 2, 1, new int[] {80,90});
	nb.add(20, 0, 1, new int[] {15,80});
	nb.add(50, 1, 0, new int[] {10,80});
	nb.add(80, 1, 1, new int[] {18,20,50});
	nb.add(90, 3, 1, new int[] {18});
        Network net = nb.getNetwork();
	SpohnTester.runSpohnNetwork(net);
    }

    public static void thirdExample() {
	int k = 1;
	int r = 3;
        boolean negative = true;
        NetworkNodeFactory factory = new SpohnNodeFactory(k, r);
        NetworkBuilder nb = new NetworkBuilder(factory, negative);
        nb.add( 10, 0, 0, new int[] {1, 35});
        nb.add( 22, 4, 0, new int[] {23});
        nb.add(  1, 0, 1, new int[] {2, 7, 10});
        nb.add( 35, 2, 1, new int[] {7, 8, 10, 23});
        nb.add( 23, 4, 1, new int[] {21, 22, 35});
        nb.add(  2, 0, 2, new int[] {1, 73});
        nb.add(  7, 1, 2, new int[] {1, 16, 35, 73});
        nb.add(  8, 2, 2, new int[] {16, 35, 65});
        nb.add( 21, 5, 2, new int[] {23, 37, 65});
        nb.add( 28, 0, 3, new int[] {73});
        nb.add( 73, 1, 3, new int[] {2, 7, 16, 28, 100});
        nb.add( 16, 2, 3, new int[] {7, 8, 65, 73, 85});
        nb.add( 65, 3, 3, new int[] {8, 16, 21, 37, 85});
        nb.add( 37, 5, 3, new int[] {21, 31, 65});
        nb.add( 41, 0, 4, new int[] {61});
        nb.add( 61, 1, 4, new int[] {38, 41, 100});
        nb.add(100, 2, 4, new int[] {11, 15, 61, 73, 85});
        nb.add( 85, 3, 4, new int[] {16, 19, 48, 65, 100});
        nb.add( 19, 4, 4, new int[] {31, 85});
        nb.add( 31, 5, 4, new int[] {3, 19, 37});
        nb.add( 38, 1, 5, new int[] {61});
        nb.add( 15, 2, 5, new int[] {100});
        nb.add( 11, 3, 5, new int[] {100});
        nb.add( 48, 4, 5, new int[] {3, 85});
        nb.add(  3, 5, 5, new int[] {31, 48});
        Network net = nb.getNetwork();
	SpohnTester.runSpohnNetwork(net);
    }
    
}