package main;
import java.util.*;

public class SpohnMessage implements NetworkMessage {
    
    public enum Phase {ONE, TWO}

    private Phase phase;
    
    private int from;

    /** 
     * Plays the role of "A" in phase one. Everyone sends one.
     *
     * Playse the role of "D" in "LocalAdvertisment" in phase two.
     */
    public List<SpohnTuple> D;

    /** "N" and "Notification" */
    public List<SpohnUnicast> notifications;

    /** "J" and "Join" */
    public List<SpohnUnicast> joins;

    /** "NA" and "NeighborhoodAdvertisment" */
    public InfoFlood na;


    public SpohnMessage(Phase phase, int from) {
        this.phase    = phase;
        this.from     = from;
        D             = new ArrayList<SpohnTuple>();
        notifications = new ArrayList<SpohnUnicast>();
        joins         = new ArrayList<SpohnUnicast>();
        na            = new InfoFlood();
    }

    public SpohnMessage(List<SpohnTuple> c, int from) {
        this(Phase.ONE, from);
        this.D = c;
    }

    public NetworkMessage getCopy() {
        SpohnMessage mess = new SpohnMessage(phase, from);
        mess.D             = new ArrayList<SpohnTuple>(D);
        mess.notifications = new ArrayList<SpohnUnicast>(notifications);
        mess.joins         = new ArrayList<SpohnUnicast>(joins);
        mess.na            = na.getCopy();
        return mess;
    }

    public Phase getPhase() {
        return phase;
    }

    public int getFrom() {
        return from;
    }
}
