package main;
import java.util.*;
import java.awt.Color;

public class SpohnNodeStatistics extends HeadStatistics {

    ArrayList<Integer> ssunknown = new ArrayList<Integer>();
    ArrayList<Integer> sspending = new ArrayList<Integer>();
    ArrayList<Integer> ssdominating = new ArrayList<Integer>();
    ArrayList<Integer> ssslave = new ArrayList<Integer>();
    ArrayList<Integer> ssgateway = new ArrayList<Integer>();
    

    public void collectHeadStatistics(Network net, NetworkNode.Type type) {
        commonCollectHeadStatistics(net,type);

	for(NetworkNode n : net.getNetworkNodes()) {
            
	    SpohnNode node = (SpohnNode)n;
            SpohnData data = node.getData();
            int id = data.getId();
            
	    for(Integer ch : data.D.keySet()) {
                addPickedNode(ch, id);
	    }
            
	    switch(data.status) {
            case UNKNOWN:
		ssunknown.add(data.id);
		break;
            case PENDING:
		sspending.add(data.id);
		break;
            case DOMINATING:
		ssdominating.add(data.id);
		break;
            case SLAVE:
		ssslave.add(data.id);
		break;
            case GATEWAY:
		ssgateway.add(data.id);
		break;
	    }
        }

        addHeadnodes(ssdominating);
    }

    public String headStatisticsToString() {
        MyStringBuffer b = new MyStringBuffer();
        super.commonHeadStatisticsToString();
        b.appendln("Nodes with status unknown: "+ssunknown.size());
        b.appendln("Nodes with status pending: "+sspending.size());
        b.appendln("Nodes with status dominating: "+ssdominating.size());
        b.appendln("Nodes with status slave: "+ssslave.size());
        b.appendln("Nodes with status gateway: "+ssgateway.size());
        return b.toString();
    }


    public Map<Integer,Color> getHeadColorMap() {
        Map<Integer,Color> colormap = new TreeMap<Integer,Color>();
        for(int number : picknodes.keySet()) {
            colormap.put(number, errorColor);
        }
        for(int number : ssdominating) {
            colormap.put(number, dominatingColor);
        }
        return colormap;
    }
}
