package main;

//import java.io.File;
import java.util.*;
import java.awt.Color;

public class SpohnTester {

    public static void main(String args[]) {
	int k = 3;
	int r = 4;
	
	//int k = 2;
	//int r = 2;
	
	//double expnhood = 5.0;
	double expnhood = 4.0;
	int areaside   = 25;
	//int areaside   = 10;
	int radiorange = 5;
	//int radiorange = 3;

	NetworkNodeFactory nfactory = new SpohnNodeFactory(k, r);
	
	Network net = null;
	if(args.length == 0) {
	    net = Network.buildNetwork(nfactory, expnhood, areaside, radiorange);
	} else if(args.length == 2){
	    long nseed = new Long(args[0]);
	    long sseed = new Long(args[1]);
	    net = Network.buildNetwork(nfactory, expnhood, areaside, radiorange, nseed, sseed);
	} else {
	    System.err.println("Wrong number of arguments!");
	    System.exit(1);
	}
	
	runSpohnNetwork(net);
    }

    public static void runSpohnNetwork(Network net) {
        boolean converged = false;
	int i = 0;
        while(!converged) {
            System.out.println("Tick "+i+"!");

	    net.stepNetwork();
            
	    converged = true;
	    for(NetworkNode n : net.getNetworkNodes()) {
                SpohnNode node = (SpohnNode)n;
		if(!node.hasConverged()){
                    converged = false;
		    break;
		}
	    }
	    i++;
	}
        printReport(net, true, true);
    }

    public static void printReport(Network net, boolean printstepreports, boolean creategraph) {

        /*
         * The network
         */
        System.out.println("Network seed:    "+net.netseed);
        System.out.println("Simulation seed: "+net.simseed);
        System.out.println(net);
	System.out.println();

        /*
         * Heads
         */
        SpohnNodeStatistics stat = new SpohnNodeStatistics();
        stat.collectHeadStatistics(net,NetworkNode.Type.SPOHN);
        System.out.println(stat.headStatisticsToString());
        System.out.println(stat.headStatisticsToString());
        System.out.println();
        System.out.println(stat.commonDetailedHeadStatisticsToString());
        
        /*
         * Stepreports
         */
        if(printstepreports) {
            for(NetworkNode n : net.getNetworkNodes()) {
                SpohnNode node = (SpohnNode)n;
                System.out.print(node.getStepReport());
                SpohnData data = node.getData();
                String str = data.nodereport.toString();
                Digraph.stringToFile(str, "nodelog-"+node.getNumber());
            }
        }



        /*
         * Networkgraph
         */
        if(creategraph) {
            Map<Integer,Color> colormap = stat.getHeadColorMap();
            Digraph.graphstringToImage(NetworkDigraph.buildDigraph(net,colormap), "network", "png", true);
        }
    }


    public static void fileNodeCenteredLog(Network net) {
    }

}
