package main;
public class SpohnTuple implements Comparable<SpohnTuple> {
    
    private int node;
    private int from;
    private int dist;

    private boolean validated;

    public SpohnTuple(int n, int f, int d, boolean val) {
	node = n;
	from = f;
	dist = d;
        validated = val;
    }

    public SpohnTuple(int n, int f, int d) {
        this(n, f, d, false);
    }

    public SpohnTuple(SpohnTuple tup) {
	node = tup.node;
	node = tup.from;
	dist = tup.dist;
        validated = tup.validated;
    }
    
    @Override 
    public boolean equals(Object o) {
	if(!(o instanceof SpohnTuple)) {
	    return false;
	}
	SpohnTuple d = (SpohnTuple)o;
	return node == d.node && from == d.from && dist == d.dist;
    }
    
    @Override
    public int hashCode() {
	return (node << 24) & (from << 16) & dist;
    }
    
    @Override 
    public int compareTo(SpohnTuple that) {
        if(this.validated != that.validated) {
            if(this.validated) {
                return -1;
            } else {
                return 1;
            }
        }
	if(this.node != that.node) {
	    return this.node - that.node;
	}
	if(this.dist != that.dist) {
	    return this.dist - that.dist;
	}
	if(this.from != that.from) {
	    return this.from - that.from;
	}
	return 0;
    }

    
    public int getNode() {
	return node;
    }

    public int getFrom() {
	return from;
    }

    public int getDist() {
	return dist;
    }

    public void setValidated(boolean val) {
        validated = val;
    }

    public boolean isValidated() {
        return validated;
    }


    public String toString() {
        String valflag = validated ? "!" : "";
        return "{"+node+valflag+","+from+","+dist+"}";
    }
}
