package main;
import java.util.*;

/* 
 * At the moment no new TreeNode objects are being created when
 * adding.  This might break stuff further on. We'll see how to deal
 * with it later on.
 *
 * The clone will not clone the contents in the tree.
 */


class TreeNode<E> extends GraphNode<E> {

    public static boolean completeToString = true;
    

//     /**
//      * Copies all fields except for parent
//      */
//     public void copyFields(TreeNode<E> node) {
// 	content  = node.content;
// 	children = node.children;
//     }

     public TreeNode(E content) {
	 super(content);
     }

    public void addChild(GraphNode<E> child) {
	if(child == null) {
	    throw new NullPointerException();
	}
	if(!(child instanceof TreeNode)) {
	    throw new RuntimeException("Tried to use a non TreeNode in a Tree!");
	}
	if(child.gotParents()) {
	    throw new RuntimeException("Tried to add another parent to a TreeNode!");
	}
	super.addChild(child);
    }

    public final List<TreeNode<E>> getTreeChildren() {
	List<TreeNode<E>> out = new LinkedList<TreeNode<E>>();
	for(GraphNode<E> g : getChildren()) {
	    if(g instanceof TreeNode) {
		out.add((TreeNode<E>)g);
	    } else {
		throw new RuntimeException("Tried to use a non TreeNode in a Tree!");
	    }
	}
	return out;
    }


//     public final List<TreeNode<E>> getChildren() {
// 	return children;
//     }

//     public final E getContent() {
// 	return content;
//     }


//     public void addChild(TreeNode<E> child) {
// 	children.add(child);
// 	child.parent = this;
//     }

//     /**
//      * Sets a child to a new tree. 
//      */
//     public void setChild(TreeNode<E> node) {
// 	boolean set = false;
// 	for(TreeNode<E> c : children) {
// 	    if(contentEquals(node)) {
// 		if(!set) {
// 		    c.copyFields(node);
// 		    set = true;
// 		} else {
// 		    throw new RuntimeException("Duplicate child!");
// 		}
// 	    }
// 	}
// 	if(!set) {
// 	    addChild(node);
// 	}
//     }

//     public boolean haveChild(E concent) {
// 	for(TreeNode<E> c : children) {
// 	    if(c.content.equals(content)) {
// 		return true;
// 	    }
// 	}
// 	return false;
//     }

//     public void removeChildren(Collection<TreeNode<E>> deletelist) {
// 	children.remove(deletelist);
//     }

//     public TreeNode<E> clone() {
// 	TreeNode<E> theclone = new TreeNode<E>(content);
// 	for(TreeNode<E> child : children) {
// 	    theclone.addChild(child.clone());
// 	}
// 	return theclone;
//     }
    
//     public int size() {
// 	int size = 1;
// 	for(TreeNode<E> child : children) {
// 	    size += child.size();
// 	}
// 	return size;
//     }

     public int height() {
 	int childheight = 0;
 	for(TreeNode<E> child : getTreeChildren()) {
 	    int h = child.height();
 	    if(h > childheight) {
 		childheight = h;
 	    }
 	}
 	return childheight + 1;
     }
    
     public boolean isLeaf() {
 	return children.size() == 0;
     }
    
    public void replaceMe(GraphNode<E> other) {
	if(other == null) {
	    throw new NullPointerException();
	}
	if(!(other instanceof TreeNode)) {
	    throw new RuntimeException("Tried to use a non TreeNode in a Tree!");
	}
	super.replaceMe(other);
    }

    public void replaceChild(GraphNode<E> oldchild, GraphNode<E> newchild) {
	if(oldchild == null || newchild == null) {
	    throw new NullPointerException();
	}
	if(!(oldchild instanceof TreeNode)) {
	    throw new RuntimeException("Tried to use a non TreeNode in a Tree!");
	}
	if(!(newchild instanceof TreeNode)) {
	    throw new RuntimeException("Tried to use a non TreeNode in a Tree!");
	}
	super.replaceChild(oldchild,newchild);
    }

     public void trimHeight(int h) {
 	if(h < 1) {
 	    throw new RuntimeException("Cannot use TreeNode.trimheight() on non-positive values");
 	} else if(h == 1) {
 	    removeChildren();
 	} else {
 	    for(TreeNode<E> child : getTreeChildren()) {
 		child.trimHeight(h-1);
 	    }
 	}
     }

    protected class TreeNodeFactory<E> implements NodeFactory<E> {
	public GraphNode<E> newNode(E content) {
	    return new TreeNode<E>(content);
	}
    }
    
//     public TreeNode<E> findChildWith(E concent) {
// 	GraphNode<E> child = super.findChildWith(content);
// // 	if(!(child instanceof TreeNode)) {
// // 	    throw new RuntimeException("Got a non TreeNode in a Tree!");
// // 	}
// 	return (TreeNode<E>)child;
//     }

    public TreeNode<E> clone() {
	return (TreeNode<E>)clone(new TreeNodeFactory());
    }



//     public void fillToString(StringBuffer b) {
// 	b.append(content.toString());
// 	if(!isLeaf()) {
// 	    b.append("{");
// 	    boolean first = true;
// 	    for(TreeNode<E> child : children) {
// 		if(!first) {
// 		    b.append(",");
// 		}
// 		first = false;
// 		child.fillToString(b);
// 	    }
// 	    b.append("}");
// 	}
//     }

//     public String toString() {
// 	StringBuffer b = new StringBuffer();
// 	fillToString(b);
// 	return b.toString();
//     }

//     public String contentToString() {
// 	return content.toString();
//     }





    public String contentToString() {
	//return "t"+content.toString();
	return content.toString();
    }






   public String treeWalkToString() {
	StringBuffer b = new StringBuffer();
	GraphWalker gw = new GraphWalker() 
	    {
		public <E> void visitNode(GraphNode<E> parent, GraphNode<E> node, GraphWalkerNodeDetails details, GraphWalkerWalkDetails walkdetails) {
		    Object o = walkdetails.visitobject;
		    if(o instanceof StringBuffer) {
			StringBuffer b = (StringBuffer)o;
			switch(details.nstate) {
			case START:
			    //System.out.println(node.contentToString()+" "+details);
			    if((details.pstate == GraphWalker.ParentState.FORWARD) || (details.pstate == GraphWalker.ParentState.BACKWARD && !details.revisit)) {
				if(details.revisit)       	b.append("(");
				if(true)                  	b.append(node.contentToString());
				if(true)                  	b.append("."+node.getNodeId());
				if(details.revisit)       	b.append(")");
			    }
			    break;
			case BEFORECHILDREN:
			    if(node.gotChildren())      b.append("{");
			    break;
			case AFTERCHILDREN:
			    if(node.gotChildren())      b.append("}");
			    break;
			case BEFOREPARENTS:
			    if(node.gotParents())      b.append("[");
			    break;
			case AFTERPARENTS:
			    if(node.gotParents())      b.append("]");
			    break;
			case END:
			    if(true)                   b.append(" ");
			    break;
			default:
			    throw new RuntimeException("Unknown NodeState"+details.nstate);
			}
		    } else {
			throw new RuntimeException("Got wrong kind of walkdetails");
		    }
		}
	    };
	GraphWalkerWalkDetails wd = new GraphWalkerWalkDetails(true,false,b);
	gw.walk(this,wd);
	return b.toString();
    }

    public String toString() {
	if(completeToString) {
	    return walkToString();
	} else {
	    return contentToString();
	}
	
    }


}